from typing import List, Tuple, Union

from lhcsmapi.Time import Time
from lhcsmapi.gui.pc.fgc_pm_event_select.FgcPmEventSelectBaseModule import FgcPmEventSelectBaseModule


class ItFgcPmEventSelectBaseModule(FgcPmEventSelectBaseModule):
    """ Specific class for search of IT FGC PM events by respective notebook browsers

    """

    def convert_fgc_pm_events_to_options(self, fgc_pm_events: List[List[Union[str, int]]]) -> List[str]:
        """ Method converting a list of source and timestamp tuples into a list of strings to be displayed

        :param fgc_pm_events: a list of FGC PM source and timestamp event tuples
        :return: list of strings with FGC PM source and timestamp
        """
        return [Time.to_string(el[1]) for el in fgc_pm_events]
