from lhcsmapi.gui.pc.fgc_pm_find_button.IpdFgcPmFindButtonBaseModule import IpdFgcPmFindButtonBaseModule
from lhcsmapi.gui.pc.fgc_pm_find_button.IpqFgcPmFindButtonBaseModule import IpqFgcPmFindButtonBaseModule
from lhcsmapi.gui.pc.fgc_pm_find_button.ItFgcPmFindButtonBaseModule import ItFgcPmFindButtonBaseModule
from lhcsmapi.gui.pc.fgc_pm_find_button.R600AFgcPmFindButtonBaseModule import R600AFgcPmFindButtonBaseModule, \
    R600ARcdoFgcPmFindButtonBaseModule, R600ARcbxhvFgcPmFindButtonBaseModule
from lhcsmapi.gui.pc.fgc_pm_find_button.R60AFgcPmFindButtonBaseModule import R60AFgcPmFindButtonBaseModule
from lhcsmapi.gui.pc.fgc_pm_find_button.R80_120AFgcPmFindButtonBaseModule import R80_120AFgcPmFindButtonBaseModule
from lhcsmapi.gui.pc.fgc_pm_find_button.RbFgcPmFindButtonBaseModule import RbFgcPmFindButtonBaseModule
from lhcsmapi.gui.pc.fgc_pm_find_button.RqFgcPmFindButtonBaseModule import RqFgcPmFindButtonBaseModule


class FgcPmFindButtonBaseModuleFactory(object):
    """ Class builds objects for FGC PM query for a selected circuit type

    """

    @staticmethod
    def create(circuit_type: str):
        """ Method creating a FgcPmFindButtonBaseModule object for a FGC PM query of a given circuit type

        :param circuit_type: circuit type to initiate a FgcPmFindButtonBaseModule object
        :return: a FgcPmFindButtonBaseModule object for a given circuit type
        """
        if circuit_type == 'RB':
            return RbFgcPmFindButtonBaseModule(circuit_type)
        elif circuit_type == 'RQ':
            return RqFgcPmFindButtonBaseModule(circuit_type)
        elif circuit_type == 'IT':
            return ItFgcPmFindButtonBaseModule(circuit_type)
        elif circuit_type == 'IPQ':
            return IpqFgcPmFindButtonBaseModule(circuit_type)
        elif circuit_type == 'IPD':
            return IpdFgcPmFindButtonBaseModule(circuit_type)
        elif circuit_type == '600A':
            return R600AFgcPmFindButtonBaseModule(circuit_type)
        elif circuit_type == '600A_RCDO':
            return R600ARcdoFgcPmFindButtonBaseModule(circuit_type)
        elif circuit_type == '600A_RCBXHV':
            return R600ARcbxhvFgcPmFindButtonBaseModule(circuit_type)
        elif circuit_type == '80-120A':
            return R80_120AFgcPmFindButtonBaseModule(circuit_type)
        elif circuit_type == '60A':
            return R60AFgcPmFindButtonBaseModule(circuit_type)
        else:
            raise ValueError('Circuit type {} not supported!'.format(circuit_type))
