class KeyTypeValidation:

    @classmethod
    def validate_key_in_kwargs(cls, key, *key_types, **kwargs):
        """ Method is validating that the key in present in the kwargs with ANY of the given types.

        :param key: name of a key in keyword-arguments dictionary
        :param key_types: a list of key types for the key
        :param kwargs: a dictionary of keyword-arguments to validate
        :return: value of the key if this given key is present in the kwargs and has any types given in key_types.
        Returns None if the key is not present in the kwargs. O
        :raise: TypeError: If the type of the key in the given kwargs is not found in the key_types list.
        """

        # TODO : raise KeyError(f"key {key} not present in keyword argument {kwargs}")
        result = kwargs.get(key, None)
        if result is not None:
            if type(result) not in key_types:
                raise TypeError("You entered a {} keyword, but the keyword needs to be a {}.".format(result, key_types))
        return result
