from io import StringIO
from unittest import TestCase
from unittest.mock import patch

from lhcsmapi.gui.pc.fgc_pm_event_select.FgcPmEventSelectBaseModuleFactory import FgcPmEventSelectBaseModuleFactory


class TestIpdFgcPmEventSelectBaseModule(TestCase):

    def test_display_qps_circuit_schematic(self):
        # arrange
        ipd_fgc_pm_module = FgcPmEventSelectBaseModuleFactory.create('IPD')

        # act
        with patch('sys.stdout', new=StringIO()) as fake_out:
            ipd_fgc_pm_module.display_qps_circuit_schematic('RD2.L1')

        # assert
        expected_out = '<IPython.core.display.Image object>'
        self.assertEqual(fake_out.getvalue().strip(), expected_out)

    def test_convert_fgc_pm_events_to_options(self):
        # arrange
        fgc_pm_events = [('RD1.L2', 1543841585220000000)]
        ipd_fgc_pm_module = FgcPmEventSelectBaseModuleFactory.create('IPD')

        # act
        options_act = ipd_fgc_pm_module.convert_fgc_pm_events_to_options(fgc_pm_events)

        # assert
        options_ref = ['2018-12-03 13:53:05.220000+01:00']
        self.assertListEqual(options_ref, options_act)
