from unittest import TestCase

from lhcsmapi.gui.pc.fgc_pm_event_select.FgcPmEventSelectBaseModuleFactory import FgcPmEventSelectBaseModuleFactory


class TestRbFgcPmEventSelectBaseModule(TestCase):
    def test_convert_fgc_pm_events_to_options(self):
        # arrange
        fgc_pm_events = [['RB.A12', 1544419882440000000],
                         ['RB.A12', 1544477282220000000],
                         ['RB.A12', 1544517631800000000],
                         ['RB.A12', 1544558894000000000],
                         ['RB.A12', 1544631694840000000]]
        rb_fgc_pm_module = FgcPmEventSelectBaseModuleFactory.create(circuit_type='RB')

        # act
        options_act = rb_fgc_pm_module.convert_fgc_pm_events_to_options(fgc_pm_events)

        # assert
        options_ref = ['2018-12-10 06:31:22.440000+01:00',
                       '2018-12-10 22:28:02.220000+01:00',
                       '2018-12-11 09:40:31.800000+01:00',
                       '2018-12-11 21:08:14+01:00',
                       '2018-12-12 17:21:34.840000+01:00']
        self.assertListEqual(options_ref, options_act)
